import {Deposit} from "@models";
import {
  isNullOrUndefined,
  KeyValue,
  TRANSLATE,
} from "solidify-frontend";
import AccessEnum = Deposit.AccessEnum;

export class AccessLevelEnumHelper {
  static getListKeyValue(): KeyValue[] {
    return [
      {
        key: AccessEnum.PUBLIC,
        value: TRANSLATE("enum.access.public"),
      },
      {
        key: AccessEnum.CLOSED,
        value: TRANSLATE("enum.access.closed"),
      },
      {
        key: AccessEnum.RESTRICTED,
        value: TRANSLATE("enum.access.restricted"),
      },
    ];
  }

  static getLabel(key: string): string {
    const item = this.getListKeyValue().find(i => i.key === key);
    if (isNullOrUndefined(item)) {
      return key;
    }
    return item.value;
  }
}
