import {
  KeyValue,
  TRANSLATE,
} from "solidify-frontend";

export enum ComplianceLevelEnum {
  NOT_ASSESSED = "NOT_ASSESSED",
  NO_COMPLIANCE = "NO_COMPLIANCE",
  WEAK_COMPLIANCE = "WEAK_COMPLIANCE",
  AVERAGE_COMPLIANCE = "AVERAGE_COMPLIANCE",
  FULL_COMPLIANCE = "FULL_COMPLIANCE",
}

export enum ComplianceLevelNumberEnum {
  NOT_ASSESSED = -1,
  NO_COMPLIANCE = 0,
  WEAK_COMPLIANCE = 1,
  AVERAGE_COMPLIANCE = 2,
  FULL_COMPLIANCE = 3,
}

export class ComplianceLevelEnumHelper {
  static getListKeyValue(): KeyValue[] {
    return [
      {
        key: ComplianceLevelEnum.FULL_COMPLIANCE,
        value: TRANSLATE("FULL_COMPLIANCE"),
      },
      {
        key: ComplianceLevelEnum.AVERAGE_COMPLIANCE,
        value: TRANSLATE("AVERAGE_COMPLIANCE"),
      },
      {
        key: ComplianceLevelEnum.WEAK_COMPLIANCE,
        value: TRANSLATE("WEAK_COMPLIANCE"),
      },
      {
        key: ComplianceLevelEnum.NO_COMPLIANCE,
        value: TRANSLATE("NO_COMPLIANCE"),
      },
      {
        key: ComplianceLevelEnum.NOT_ASSESSED,
        value: TRANSLATE("NOT_ASSESSED"),
      },
    ];
  }
}
