import {
  KeyValue,
  TRANSLATE,
} from "solidify-frontend";

export enum DataFileStatusEnum {
  IN_ERROR = "IN_ERROR",
  READY = "READY",
  RECEIVED = "RECEIVED",
  CHANGE_RELATIVE_LOCATION = "CHANGE_RELATIVE_LOCATION",
  TO_PROCESS = "TO_PROCESS",
  PROCESSED = "PROCESSED",
  FILE_FORMAT_IDENTIFIED = "FILE_FORMAT_IDENTIFIED",
  FILE_FORMAT_UNKNOWN = "FILE_FORMAT_UNKNOWN",
  VIRUS_CHECKED = "VIRUS_CHECKED",
  CLEANING = "CLEANING",
  CLEANED = "CLEANED",
  IGNORED_FILE = "IGNORED_FILE",
  EXCLUDED_FILE = "EXCLUDED_FILE"
}

export class DataFileStatusEnumHelper {
  static getListKeyValue(): KeyValue[] {
    return [
      {
        key: DataFileStatusEnum.IN_ERROR,
        value: TRANSLATE("IN_ERROR"),
      },
      {
        key: DataFileStatusEnum.READY,
        value: TRANSLATE("READY"),
      },
      {
        key: DataFileStatusEnum.RECEIVED,
        value: TRANSLATE("RECEIVED"),
      },
      {
        key: DataFileStatusEnum.CHANGE_RELATIVE_LOCATION,
        value: TRANSLATE("CHANGE_RELATIVE_LOCATION"),
      },
      {
        key: DataFileStatusEnum.TO_PROCESS,
        value: TRANSLATE("TO_PROCESS"),
      },
      {
        key: DataFileStatusEnum.PROCESSED,
        value: TRANSLATE("PROCESSED"),
      },
      {
        key: DataFileStatusEnum.FILE_FORMAT_IDENTIFIED,
        value: TRANSLATE("FILE_FORMAT_IDENTIFIED"),
      },
      {
        key: DataFileStatusEnum.FILE_FORMAT_UNKNOWN,
        value: TRANSLATE("FILE_FORMAT_UNKNOWN"),
      },
      {
        key: DataFileStatusEnum.VIRUS_CHECKED,
        value: TRANSLATE("VIRUS_CHECKED"),
      },
      {
        key: DataFileStatusEnum.CLEANING,
        value: TRANSLATE("CLEANING"),
      },
      {
        key: DataFileStatusEnum.EXCLUDED_FILE,
        value: TRANSLATE("EXCLUDED_FILE"),
      },
      {
        key: DataFileStatusEnum.IGNORED_FILE,
        value: TRANSLATE("IGNORED_FILE"),
      },
      {
        key: DataFileStatusEnum.CLEANED,
        value: TRANSLATE("CLEANED"),
      }
    ];
  }
}
