import {Deposit} from "@models";
import {
  KeyValue,
  TRANSLATE,
} from "solidify-frontend";

export class DepositStatusEnumHelper {
  static getListKeyValue(): KeyValue[] {
    return [
      {
        key: Deposit.StatusEnum.INPROGRESS,
        value: TRANSLATE("IN_PROGRESS"),
      },
      {
        key: Deposit.StatusEnum.INVALIDATION,
        value: TRANSLATE("IN_VALIDATION"),
      },
      {
        key: Deposit.StatusEnum.REJECTED,
        value: TRANSLATE("REJECTED"),
      },
      {
        key: Deposit.StatusEnum.INERROR,
        value: TRANSLATE("IN_ERROR"),
      },
      {
        key: Deposit.StatusEnum.PAUSED,
        value: TRANSLATE("PAUSED"),
      },
      {
        key: Deposit.StatusEnum.CHECKED,
        value: TRANSLATE("CHECKED"),
      },
      {
        key: Deposit.StatusEnum.REJECTED,
        value: TRANSLATE("REJECTED"),
      },
      {
        key: Deposit.StatusEnum.APPROVED,
        value: TRANSLATE("APPROVED"),
      },
      {
        key: Deposit.StatusEnum.SUBMITTED,
        value: TRANSLATE("SUBMITTED"),
      },
      {
        key: Deposit.StatusEnum.COMPLETED,
        value: TRANSLATE("COMPLETED"),
      },
      {
        key: Deposit.StatusEnum.CLEANING,
        value: TRANSLATE("CLEANING"),
      },
      {
        key: Deposit.StatusEnum.CLEANED,
        value: TRANSLATE("CLEANED"),
      },
    ];
  }
}
