import {
  KeyValue,
  TRANSLATE,
} from "solidify-frontend";

export enum PackageStatusEnum {
  IN_ERROR = "IN_ERROR",
  IN_PROGRESS = "IN_PROGRESS",
  COMPLETED = "COMPLETED",
  IN_PREPARATION = "IN_PREPARATION",
  READY = "READY",
  CHECKING = "CHECKING",
  CHECKED = "CHECKED",
  STORED = "STORED",
  INDEXING = "INDEXING",
  REINDEXING = "REINDEXING",
  DOWNLOADING = "DOWNLOADING",
  RELOADED = "RELOADED",
  PRESERVATION_ERROR = "PRESERVATION_ERROR",
  CLEANING = "CLEANING",
  CLEANED = "CLEANED"
}

export class PackageStatusEnumHelper {
  static getListKeyValue(): KeyValue[] {
    return [
      {
        key: PackageStatusEnum.IN_ERROR,
        value: TRANSLATE("enum.packageStatus.inError"),
      },
      {
        key: PackageStatusEnum.IN_PROGRESS,
        value: TRANSLATE("enum.packageStatus.inProgress"),
      },
      {
        key: PackageStatusEnum.COMPLETED,
        value: TRANSLATE("enum.packageStatus.completed"),
      },
      {
        key: PackageStatusEnum.IN_PREPARATION,
        value: TRANSLATE("enum.packageStatus.inPreparation"),
      },
      {
        key: PackageStatusEnum.READY,
        value: TRANSLATE("enum.packageStatus.ready"),
      },
      {
        key: PackageStatusEnum.CHECKING,
        value: TRANSLATE("enum.packageStatus.checking"),
      },
      {
        key: PackageStatusEnum.CHECKED,
        value: TRANSLATE("enum.packageStatus.checked"),
      },
      {
        key: PackageStatusEnum.STORED,
        value: TRANSLATE("enum.packageStatus.stored"),
      },
      {
        key: PackageStatusEnum.INDEXING,
        value: TRANSLATE("enum.packageStatus.indexing"),
      },
      {
        key: PackageStatusEnum.REINDEXING,
        value: TRANSLATE("enum.packageStatus.reindexing"),
      },
      {
        key: PackageStatusEnum.DOWNLOADING,
        value: TRANSLATE("enum.packageStatus.downloading"),
      },
      {
        key: PackageStatusEnum.RELOADED,
        value: TRANSLATE("enum.packageStatus.reloaded"),
      },
      {
        key: PackageStatusEnum.PRESERVATION_ERROR,
        value: TRANSLATE("enum.packageStatus.preservationError"),
      },
      {
        key: PackageStatusEnum.CLEANING,
        value: TRANSLATE("enum.packageStatus.cleaning"),
      },
      {
        key: PackageStatusEnum.CLEANED,
        value: TRANSLATE("enum.packageStatus.cleaned"),
      },
    ];
  }
}
