import {
  isNullOrUndefined,
  KeyValue,
  TRANSLATE,
} from "solidify-frontend";

export enum LanguagesEnum {
  fr = "fr",
  de = "de",
  en = "en",
}

export class LanguagesEnumHelper {
  static getListKeyValue(): KeyValue[] {
    return [
      {
        key: LanguagesEnum.en,
        value: TRANSLATE("language.english"),
      },
      {
        key: LanguagesEnum.de,
        value: TRANSLATE("language.german"),
      },
      {
        key: LanguagesEnum.fr,
        value: TRANSLATE("language.french"),
      },
    ];
  }

  static getLabel(key: string): string {
    const item = this.getListKeyValue().find(i => i.key === key);
    if (isNullOrUndefined(item)) {
      return key;
    }
    return item.value;
  }
}
