import {Checksum} from "@deposit/models/checksum.model";
import {
  AipChecksumCheck,
  AipFileFormat,
  ChangeInfo,
} from "@models";
import {DataFileStatusEnum} from "@shared/enums/business/data-file-status.enum";
import {DataCategoryEnum} from "@shared/enums/data-category.enum";
import {DataTypeEnum} from "@shared/enums/data-type.enum";

export interface DataFile {
  resId?: string;
  creation?: ChangeInfo;
  lastUpdate?: ChangeInfo;
  sourceData?: string;
  status?: DataFileStatusEnum;
  statusMessage?: string;
  virusCheck?: AipChecksumCheck;
  smartSize?: string;
  relativeLocation?: string;
  packageId?: string;
  initialPath?: string;
  finalData?: string;
  fileSize?: number;
  fileName?: string;
  fileFormat?: AipFileFormat;
  dataCategory?: DataCategoryEnum;
  dataType?: DataTypeEnum;
  complianceLevel?: string;
  checksums?: Checksum[];
  available?: boolean;
}
