import {ChangeInfo} from "@models";
import {JobStatusEnum} from "@shared/enums/business/job-status.enum";
import {JobExecutionReport} from "@shared/models/business/job-execution-report.model";

export interface JobExecution {
  resId: string;
  jobId?: string;
  runNumber?: number;
  status?: JobStatusEnum;
  statusMessage?: string;
  startDate?: Date;
  endDate?: Date;
  processedItems?: number;
  ignoredItems?: number;
  inErrorItems?: number;
  completionStatus?: number;
  totalItems?: number;
  creation?: ChangeInfo;
  lastUpdate?: ChangeInfo;
  executionReports?: JobExecutionReport[];
}
