import {DragDropModule} from "@angular/cdk/drag-drop";
import {LayoutModule} from "@angular/cdk/layout";
import {TextFieldModule} from "@angular/cdk/text-field";
import {CommonModule} from "@angular/common";
import {NgModule} from "@angular/core";
import {
  FormsModule,
  ReactiveFormsModule,
} from "@angular/forms";
import {
  MAT_DIALOG_DEFAULT_OPTIONS,
  MatDialogConfig,
} from "@angular/material/dialog";
import {MatSpinner} from "@angular/material/progress-spinner";
import {MaterialModule} from "@app/material.module";
import {SharedDataTablePresentational} from "@app/shared/components/presentationals/shared-data-table/shared-data-table.presentational";
import {SharedErrorPresentational} from "@app/shared/components/presentationals/shared-error/shared-error.presentational";
import {SharedFieldErrorPresentational} from "@app/shared/components/presentationals/shared-field-error/shared-field-error.presentational";
import {SharedMultiSelectPresentational} from "@app/shared/components/presentationals/shared-multi-select/shared-multi-select.presentational";
import {SharedSearchPresentational} from "@app/shared/components/presentationals/shared-search/shared-search.presentational";
import {FileSizePipe} from "@app/shared/pipes/file-size.pipe";
import {SharedInstitutionState} from "@app/shared/stores/institution/shared-institution.state";
import {SharedLanguageState} from "@app/shared/stores/language/shared-language.state";
import {SharedLicenseState} from "@app/shared/stores/license/shared-license.state";
import {SharedOrganizationalUnitState} from "@app/shared/stores/organizational-unit/shared-organizational-unit.state";
import {SharedPersonState} from "@app/shared/stores/person/shared-person.state";
import {SharedPreservationPolicyState} from "@app/shared/stores/preservation-policy/shared-preservation-policy.state";
import {SharedState} from "@app/shared/stores/shared.state";
import {SharedSubmissionPolicyState} from "@app/shared/stores/submission-policy/shared-submission-policy.state";
import {
  FaIconLibrary,
  FontAwesomeModule,
} from "@fortawesome/angular-fontawesome";
import {fas} from "@fortawesome/free-solid-svg-icons";
import {TranslateModule} from "@ngx-translate/core";
import {NgxsModule} from "@ngxs/store";
import {SharedOrganizationalUnitNameContainer} from "@shared/components/containers/shared-organizational-unit-name/shared-organizational-unit-name.container";
import {SharedTabsContainer} from "@shared/components/containers/shared-tabs/shared-tabs.container";
import {SharedAipDetailDialog} from "@shared/components/dialogs/shared-aip-detail/shared-aip-detail.dialog";
import {SharedBaseActionDialog} from "@shared/components/dialogs/shared-base-action/shared-base-action.dialog";
import {SharedBaseInfoDialog} from "@shared/components/dialogs/shared-base-info/shared-base-info.dialog";
import {SharedConfirmDialog} from "@shared/components/dialogs/shared-confirm/shared-confirm.dialog";
import {SharedDataTableLooseSelectionDialog} from "@shared/components/dialogs/shared-data-table-loose-selection/shared-data-table-loose-selection.dialog";
import {SharedFileDetailDialog} from "@shared/components/dialogs/shared-file-detail/shared-file-detail.dialog";
import {SharedHistoryDialog} from "@shared/components/dialogs/shared-history/shared-history.dialog";
import {SharedInfoExcludedIgnoredFileDialog} from "@shared/components/dialogs/shared-info-excluded-ignored-file/shared-info-excluded-ignored-file.dialog";
import {AipStatusNamePresentational} from "@shared/components/presentationals/aip-status-name/aip-status-name.presentational";
import {AipStatusOrgunitNamePresentational} from "@shared/components/presentationals/aip-status-orgunit-name/aip-status-orgunit-name.presentational";
import {AipStatusSummaryPresentational} from "@shared/components/presentationals/aip-status-summary/aip-status-summary.presentational";
import {ButtonToolbarDetailPresentational} from "@shared/components/presentationals/button-toolbar-detail/button-toolbar-detail.presentational";
import {SharedAdminResearchDomainLabelPresentational} from "@shared/components/presentationals/shared-admin-research-domain-label/shared-admin-research-domain-label.presentational";
import {SharedBannerEditModePresentational} from "@shared/components/presentationals/shared-banner-edit-mode/shared-banner-edit-mode.presentational";
import {SharedBannerPresentational} from "@shared/components/presentationals/shared-banner/shared-banner.presentational";
import {SharedButtonIdPresentational} from "@shared/components/presentationals/shared-button-id/shared-button-id.presentational";
import {SharedButtonStatusHistoryPresentational} from "@shared/components/presentationals/shared-button-status-history/shared-button-status-history.presentational";
import {SharedChecksumPresentational} from "@shared/components/presentationals/shared-checksum/shared-checksum.presentational";
import {SharedComplianceLevelPresentational} from "@shared/components/presentationals/shared-compliance-level/shared-compliance-level.presentational";
import {SharedDatafileQuickStatusPresentational} from "@shared/components/presentationals/shared-datafile-quick-status/shared-datafile-quick-status.presentational";
import {SharedDoiMenuPresentational} from "@shared/components/presentationals/shared-doi-menu/shared-doi-menu.presentational";
import {SharedKeywordInputPresentational} from "@shared/components/presentationals/shared-keyword-input/shared-keyword-input.presentational";
import {SharedMultiSelectContentPresentational} from "@shared/components/presentationals/shared-multi-select-content/shared-multi-select-content.presentational";
import {SharedMultiSelectDefaultValueContentPresentational} from "@shared/components/presentationals/shared-multi-select-default-value-content/shared-multi-select-default-value-content.presentational";
import {SharedPanelExpandablePresentational} from "@shared/components/presentationals/shared-panel-expandable/shared-panel-expandable.presentational";
import {SharedPersonForm} from "@shared/components/presentationals/shared-person-form/shared-person-form";
import {SharedPersonOrgunitRolePresentational} from "@shared/components/presentationals/shared-person-orgunit-role/shared-person-orgunit-role.presentational";
import {SharedSearchableMultiSelectContentPresentational} from "@shared/components/presentationals/shared-searchable-multi-select-content/shared-searchable-multi-select-content.presentational";
import {SharedSearchableMultiSelectPresentational} from "@shared/components/presentationals/shared-searchable-multi-select/shared-searchable-multi-select.presentational";
import {SharedSearchableSingleSelectContentPresentational} from "@shared/components/presentationals/shared-searchable-single-select-content/shared-searchable-single-select-content.presentational";
import {SharedSearchableSingleSelectPresentational} from "@shared/components/presentationals/shared-searchable-single-select/shared-searchable-single-select.presentational";
import {SharedSnackbarPresentational} from "@shared/components/presentationals/shared-snackbar/shared-snackbar.presentational";
import {SharedStarRatingPresentational} from "@shared/components/presentationals/shared-star-rating/shared-star-rating.presentational";
import {SharedTocPresentational} from "@shared/components/presentationals/shared-toc/shared-toc.presentational";
import {SharedUrlInputNavigationPresentational} from "@shared/components/presentationals/shared-url-input-navigation/shared-url-input-navigation.presentational";
import {SharedAlternativeButtonDirective} from "@shared/directives/shared-alternative-button/shared-alternative-button.directive";
import {SharedButtonSpinnerDirective} from "@shared/directives/shared-button-spinner/shared-button-spinner.directive";
import {SharedMatButtonThemeDirective} from "@shared/directives/shared-mat-button-theme/shared-mat-button-theme.directive";
import {SharedSpinnerDirective} from "@shared/directives/shared-spinner/shared-spinner.directive";
import {ClonePipe} from "@shared/pipes/clone.pipe";
import {DatetimePipe} from "@shared/pipes/datetime.pipe";
import {SolidifyAsyncPipe} from "@shared/pipes/solidify-async.pipe";
import {AppStatusService} from "@shared/services/app-status.service";
import {BreakpointService} from "@shared/services/breakpoint.service";
import {CanDeactivateGuard} from "@shared/services/can-deactivate-guard.service";
import {SecurityService} from "@shared/services/security.service";
import {SharedDisseminationPolicyState} from "@shared/stores/dissemination-policy/shared-dissemination-policy.state";
import {SharedFundingAgencyState} from "@shared/stores/funding-agency/shared-funding-agency.state";
import {SharedOrganizationalUnitDisseminationPolicyState} from "@shared/stores/organizational-unit/dissemination-policy/shared-organizational.unit-dissemination-policy.state";
import {SharedOrganizationalUnitPreservationPolicyState} from "@shared/stores/organizational-unit/preservation-policy/shared-organizational-unit-preservation-policy.state";
import {SharedOrganizationalUnitSubmissionPolicyState} from "@shared/stores/organizational-unit/submission-policy/shared-organizational-unit-submission-policy.state";
import {SharedRoleState} from "@shared/stores/role/shared-role.state";
import {HighlightModule} from "ngx-highlightjs";
import {TableModule} from "primeng/table";
import {SolidifyFrontendModule} from "solidify-frontend";
import {SharedBreadcrumbPresentational} from "./components/presentationals/shared-breadcrumb/shared-breadcrumb.presentational";
import {SharedPaginatorPresentational} from "./components/presentationals/shared-paginator/shared-paginator.presentational";

const routables = [];
const containers = [
  SharedOrganizationalUnitNameContainer,
  SharedTabsContainer,
];
const dialogs = [
  SharedBaseActionDialog,
  SharedBaseInfoDialog,
  SharedHistoryDialog,
  SharedFileDetailDialog,
  SharedAipDetailDialog,
  SharedDataTableLooseSelectionDialog,
  SharedConfirmDialog,
  SharedInfoExcludedIgnoredFileDialog,
];
const contents = [
  SharedSearchableSingleSelectContentPresentational,
  SharedSearchableMultiSelectContentPresentational,
  SharedMultiSelectContentPresentational,
  SharedMultiSelectDefaultValueContentPresentational,
];
const presentationals = [
  SharedTocPresentational,
  ButtonToolbarDetailPresentational,
  SharedComplianceLevelPresentational,
  SharedSearchPresentational,
  SharedDataTablePresentational,
  SharedPaginatorPresentational,
  SharedBreadcrumbPresentational,
  SharedMultiSelectPresentational,
  SharedFieldErrorPresentational,
  SharedErrorPresentational,
  SharedSearchableSingleSelectPresentational,
  SharedSearchableMultiSelectPresentational,
  SharedButtonStatusHistoryPresentational,
  SharedPersonForm,
  SharedPersonOrgunitRolePresentational,
  SharedSnackbarPresentational,
  AipStatusSummaryPresentational,
  AipStatusNamePresentational,
  AipStatusOrgunitNamePresentational,
  SharedStarRatingPresentational,
  SharedDoiMenuPresentational,
  SharedButtonIdPresentational,
  SharedBannerPresentational,
  SharedBannerEditModePresentational,
  SharedPanelExpandablePresentational,
  SharedChecksumPresentational,
  SharedDatafileQuickStatusPresentational,
  SharedAdminResearchDomainLabelPresentational,
  SharedKeywordInputPresentational,
  SharedUrlInputNavigationPresentational,
];
const directives = [
  SharedSpinnerDirective,
  SharedButtonSpinnerDirective,
  SharedAlternativeButtonDirective,
  SharedMatButtonThemeDirective,
];
const pipes = [
  FileSizePipe,
  DatetimePipe,
  ClonePipe,
  SolidifyAsyncPipe,
];
const services = [
  CanDeactivateGuard,
  BreakpointService,
  AppStatusService,
  SecurityService,
];
const modules = [
  CommonModule,
  FormsModule,
  ReactiveFormsModule,
  MaterialModule,
  FontAwesomeModule,
  TableModule,
  TranslateModule,
  SolidifyFrontendModule,
  TextFieldModule,
  LayoutModule,
  DragDropModule,
  HighlightModule,
];

@NgModule({
  declarations: [
    ...routables,
    ...containers,
    ...dialogs,
    ...contents,
    ...presentationals,
    ...directives,
    ...pipes,
  ],
  imports: [
    ...modules,
    NgxsModule.forFeature([
      SharedState,
      SharedLicenseState,
      SharedLanguageState,
      SharedPreservationPolicyState,
      SharedSubmissionPolicyState,
      SharedOrganizationalUnitState,
      SharedDisseminationPolicyState,
      SharedPersonState,
      SharedInstitutionState,
      SharedRoleState,
      SharedOrganizationalUnitSubmissionPolicyState,
      SharedOrganizationalUnitPreservationPolicyState,
      SharedOrganizationalUnitDisseminationPolicyState,
      SharedFundingAgencyState,
    ]),
  ],
  exports: [
    ...modules,
    ...routables,
    ...containers,
    ...dialogs,
    ...presentationals,
    ...contents,
    ...directives,
    ...pipes,
  ],
  providers: [
    ...services,
    {provide: MAT_DIALOG_DEFAULT_OPTIONS, useValue: {panelClass: "dlcm-dialogs", hasBackdrop: true} as MatDialogConfig},
  ],
  entryComponents: [
    ...dialogs,
    SharedSnackbarPresentational,
    SharedErrorPresentational,
    ...contents,
    MatSpinner,
  ],
})
export class SharedModule {
  constructor(private library: FaIconLibrary) {
    // Fontawesome library
    library.addIconPacks(fas);
  }
}
