import {DisseminationPolicy} from "@models";
import {AdminResourceApiEnum} from "@app/shared/enums/api.enum";
import {
  Actions,
  State,
  Store,
} from "@ngxs/store";
import {sharedDisseminationPolicyActionNameSpace} from "@shared/stores/dissemination-policy/shared-dissemination-policy.action";
import {
  ApiService,
  defaultResourceStateInitValue,
  NotificationService,
  ResourceState,
  ResourceStateModel,
} from "solidify-frontend";
import {LocalStateEnum} from "../../enums/local-state.enum";

export interface SharedDisseminationPolicyStateModel extends ResourceStateModel<DisseminationPolicy> {
}

@State<SharedDisseminationPolicyStateModel>({
  name: LocalStateEnum.shared_dissemination_policy,
  defaults: {
    ...defaultResourceStateInitValue(),
  },
})
export class SharedDisseminationPolicyState extends ResourceState<SharedDisseminationPolicyStateModel, DisseminationPolicy> {
  constructor(protected apiService: ApiService,
              protected store: Store,
              protected notificationService: NotificationService,
              protected actions$: Actions) {
    super(apiService, store, notificationService, actions$, {
      nameSpace: sharedDisseminationPolicyActionNameSpace,
    });
  }

  protected get _urlResource(): string {
    return AdminResourceApiEnum.disseminationPolicies;
  }
}
