import {PreservationPolicy} from "@models";
import {AdminResourceApiEnum} from "@app/shared/enums/api.enum";
import {sharedPreservationPolicyActionNameSpace} from "@app/shared/stores/preservation-policy/shared-preservation-policy.action";
import {
  Actions,
  State,
  Store,
} from "@ngxs/store";
import {
  ApiService,
  defaultResourceStateInitValue,
  NotificationService,
  ResourceState,
  ResourceStateModel,
} from "solidify-frontend";
import {LocalStateEnum} from "../../enums/local-state.enum";

export interface SharedPreservationPolicyStateModel extends ResourceStateModel<PreservationPolicy> {
}

@State<SharedPreservationPolicyStateModel>({
  name: LocalStateEnum.shared_preservationPolicy,
  defaults: {
    ...defaultResourceStateInitValue(),
  },
})
export class SharedPreservationPolicyState extends ResourceState<SharedPreservationPolicyStateModel, PreservationPolicy> {
  constructor(protected apiService: ApiService,
              protected store: Store,
              protected notificationService: NotificationService,
              protected actions$: Actions) {
    super(apiService, store, notificationService, actions$, {
      nameSpace: sharedPreservationPolicyActionNameSpace,
    });
  }

  protected get _urlResource(): string {
    return AdminResourceApiEnum.preservationPolicies;
  }
}
