import {AdminDisseminationPolicyDeleteDialog} from "@admin/dissemination-policy/components/dialogs/admin-dissemination-policy-delete/admin-dissemination-policy-delete.dialog";
import {AdminFundingAgencyDeleteDialog} from "@admin/funding-agencies/components/dialogs/admin-funding-agency-delete/admin-funding-agency-delete.dialog";
import {AdminInstitutionDeleteDialog} from "@admin/institution/components/dialogs/admin-institution-delete/admin-institution-delete.dialog";
import {AdminLanguageDeleteDialog} from "@admin/language/components/dialogs/admin-language-delete/admin-language-delete.dialog";
import {AdminLicenseDeleteDialog} from "@admin/license/components/dialogs/admin-license-delete/admin-license-delete.dialog";
import {AdminMetadataTypeDeleteDialog} from "@admin/metadata-type/components/dialogs/admin-metadata-type-delete/admin-metadata-type-delete.dialog";
import {AdminOaiSetDeleteDialog} from "@admin/oai-set/components/dialogs/admin-oai-set-delete/admin-oai-set-delete.dialog";
import {AdminOauth2ClientDeleteDialog} from "@admin/oauth2-client/components/dialogs/admin-oauth2-client-delete/admin-oauth2-client-delete.dialog";
import {AdminOrgunitDeleteDialog} from "@admin/orgunit/components/dialogs/admin-orgunit-delete/admin-orgunit-delete.dialog";
import {AdminPersonDeleteDialog} from "@admin/person/components/dialogs/admin-person-delete/admin-person-delete.dialog";
import {AdminPreservationPolicyDeleteDialog} from "@admin/preservation-policy/components/dialogs/admin-preservation-policy-delete/admin-preservation-policy-delete.dialog";
import {AdminResearchDomainDeleteDialog} from "@admin/research-domain/components/dialogs/admin-research-domain-delete/admin-research-domain-delete.dialog";
import {AdminSubmissionPolicyDeleteDialog} from "@admin/submission-policy/components/dialogs/admin-submission-policy-delete/admin-submission-policy-delete.dialog";
import {AdminUserDeleteDialog} from "@admin/user/components/dialogs/admin-user-delete/admin-user-delete.dialog";
import {Component} from "@angular/core";
import {OrderAllOrderDeleteDialog} from "@app/features/order/features/all-order/components/dialogs/all-order-delete/order-all-order-delete.dialog";
import {JobDeleteDialog} from "@app/features/preservation/job/components/dialogs/job-delete/job-delete.dialog";
import {LocalStateEnum} from "@app/shared/enums/local-state.enum";
import {DepositDeleteDialog} from "@deposit/components/dialogs/deposit-delete/deposit-delete.dialog";
import {OrderMyOrderDeleteDialog} from "@order/features/my-order/components/dialogs/my-order-delete/order-my-order-delete.dialog";
import {StringUtil} from "solidify-frontend";

export class StoreDialogUtil {
  private static readonly messageNotFound: string = "There is no dialog for action '{0}' declared for the state '{1}'. Please add if statement into StoreDialogUtil static class.";

  static delete(state: LocalStateEnum): Component {
    if (state === LocalStateEnum.deposit) {
      return DepositDeleteDialog as Component;
    }
    if (state === LocalStateEnum.admin_organizationalUnit) {
      return AdminOrgunitDeleteDialog as Component;
    }
    if (state === LocalStateEnum.admin_submissionPolicy) {
      return AdminSubmissionPolicyDeleteDialog as Component;
    }
    if (state === LocalStateEnum.admin_preservationPolicy) {
      return AdminPreservationPolicyDeleteDialog as Component;
    }
    if (state === LocalStateEnum.admin_disseminationPolicy) {
      return AdminDisseminationPolicyDeleteDialog as Component;
    }
    if (state === LocalStateEnum.admin_license) {
      return AdminLicenseDeleteDialog as Component;
    }
    if (state === LocalStateEnum.admin_institution) {
      return AdminInstitutionDeleteDialog as Component;
    }
    if (state === LocalStateEnum.admin_researchDomain) {
      return AdminResearchDomainDeleteDialog as Component;
    }
    if (state === LocalStateEnum.admin_user) {
      return AdminUserDeleteDialog as Component;
    }
    if (state === LocalStateEnum.admin_oaiSet) {
      return AdminOaiSetDeleteDialog as Component;
    }
    if (state === LocalStateEnum.admin_oauth2Client) {
      return AdminOauth2ClientDeleteDialog as Component;
    }
    if (state === LocalStateEnum.admin_person) {
      return AdminPersonDeleteDialog as Component;
    }
    if (state === LocalStateEnum.admin_fundingAgencies) {
      return AdminFundingAgencyDeleteDialog as Component;
    }
    if (state === LocalStateEnum.admin_language) {
      return AdminLanguageDeleteDialog as Component;
    }
    if (state === LocalStateEnum.admin_metadataType) {
      return AdminMetadataTypeDeleteDialog as Component;
    }
    if (state === LocalStateEnum.preservation_job) {
      return JobDeleteDialog as Component;
    }
    if (state === LocalStateEnum.order_allOrder) {
      return OrderAllOrderDeleteDialog as Component;
    }
    if (state === LocalStateEnum.order_myOrder) {
      return OrderMyOrderDeleteDialog as Component;
    }
    throw Error(StringUtil.format(StoreDialogUtil.messageNotFound, "Delete", state));
  }
}
